#ifndef INCLUDEALL_INCLUDED
#define INCLUDEALL_INCLUDED


#include <vector>
#include <xsi_application.h>
#include <xsi_context.h>
#include <xsi_pluginregistrar.h>
#include <xsi_status.h>
#ifndef linux
#define WIN32_LEAN_AND_MEAN
#include <windows.h> // Needed for OpenGL on windows
#endif

#include "GL/glew.h"
#if defined(_WIN32)
#  include "GL/wglew.h"
#elif !defined(__APPLE__) || defined(GLEW_APPLE_GLX)
#  include "GL/glxew.h"
#endif

#include <xsi_math.h>
#include <xsi_argument.h>
#include <xsi_toolcontext.h>
#include <xsi_menu.h>
#include <xsi_menuitem.h>
#include <xsi_utils.h>
#include <xsi_plugin.h>
#include <xsi_selection.h>
#include <xsi_comapihandler.h>
#include <xsi_preferences.h>
#include <xsi_view.h>
#include <xsi_layout.h>
#include <xsi_desktop.h>
#include <xsi_siobject.h>
#include <xsi_operator.h>
#include <xsi_project.h>
#include <xsi_scene.h>
#include <xsi_scenerenderproperty.h>
#include <xsi_pass.h>
#include <xsi_renderer.h>
#include <xsi_light.h>
#include <xsi_lightrig.h>
#include <xsi_camera.h>
#include <xsi_property.h>
#include <xsi_shader.h>

#include <xsi_polygonmesh.h>
#include <xsi_point.h>
#include <xsi_edge.h>
#include <xsi_vertex.h>
#include <xsi_triangle.h>
#include <xsi_polygonnode.h>
#include <xsi_polygonface.h>
#include <xsi_primitive.h>
#include <xsi_geometryaccessor.h>
#include <xsi_subcomponent.h>
#include <xsi_model.h>
#include <xsi_iceattribute.h>
#include <xsi_iceattributedataarray.h>
#include <xsi_nurbscurvelist.h>
#include <xsi_nurbscurve.h>
#include <xsi_subcomponent.h>
#include <xsi_nurbssurfacemesh.h>
#include <xsi_nurbssurface.h>


#include <xsi_kinematics.h>

#include "ogl_primitives.h"
#include "ogl_helpers.h"
#include "math_helpers.h"

#include "ToolButton.h"

#include "ButtonBar.h"
#include "PieMenu.h"
#include "logmsg.h"
#include "subdivide.h"



using namespace XSI::MATH; 
using namespace XSI; 

const GLubyte halftonePolyMask[] = {
									0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
									0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
									0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
									0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
									0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
									0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
									0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
									0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,	
									0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
									0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
									0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
									0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,	
									0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
									0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
									0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
									0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,};

const static int highlightColorR=100;
const static int highlightColorG=200;
const static int highlightColorB=100;
const static int highlightColorA=100;
const static int normalColorR=225;
const static int normalColorG=115;
const static int normalColorB=00;
const static float normalWidth=2.0;

#define kHandleDragThreshold			5	 // pixels
#define kGestureDragThreshold			10	 // pixels

#define kSubdiv1	0x4A			// J
#define kSubdiv2	0x4B			// K
#define kSubdiv3 	0x4C			// L

enum {
	kNoDragAxis = -1,
	kXDragAxis,
	kYDragAxis,
	kZDragAxis,
	kGridDrag,
};


#endif